class CodeParser

	def initialize(output)
		@raw_routes_output = output
	end

	#returns an empty array if no api_endpoints in code
	def api_endpoints(output = @raw_routes_output)
		endpoints = []
		parsed_routes(output).each do |route|
			if route[:route] != nil
				if route[:route].include?('/api')
          endpoints << route[:route]
        end
			end
		end
		endpoints
	end

  def public_api_endpoints(output = @raw_routes_output)
    endpoints = []
		parsed_routes(output).each do |route|
			if route[:route] != nil
				if route[:route].include?('/api/public')
          endpoints << route[:route]
        end
			end
		end
		endpoints
  end

	def all_endpoints(output = @raw_routes_output)
	endpoints = []
		parsed_routes(output).each do |route|
			endpoints << route[:route] if route[:route] != nil
		end
		endpoints
	end

	#returns all route http request type
	def http_requests(output = @raw_routes_output)
		request_type = []
		parsed_routes(output).each do |route|
			if route[:request_type] != nil && route[:route] != nil
				if route[:request_type] =~ /[\/]/
					request_type << route[:type]
				elsif route[:route].include?('/api')
					request_type << route[:request_type]
				end
			end
		end
		request_type.sort
	end

  def public_http_requests(output = @raw_routes_output)
    request_type = []
		parsed_routes(output).each do |route|
			if route[:request_type] != nil && route[:route] != nil
				if route[:request_type] =~ /[\/]/
					request_type << route[:type]
				elsif route[:route].include?('/api/public')
					request_type << route[:request_type]
				end
			end
		end
		request_type.sort
  end

	def parsed_routes(output = raw_routes_output)
		#add 'none specified'
		routes = []
		output.strip.each_line do |line|
			split = line.split(' ')
			route = {}
			route[:type]         = split[0]
			route[:request_type] = split[1]
			route[:route]        = split[2]
			route[:controller]   = split[3]
			route[:action]       = split[4]
			routes << route
		end
		routes
	end

end
